xref: /freebsd/tests/sys/acl/01.sh (revision 315ee00f)
1#!/bin/sh
2#
3# Copyright (c) 2008, 2009 Edward Tomasz Napierała <trasz@FreeBSD.org>
4#
5# Redistribution and use in source and binary forms, with or without
6# modification, are permitted provided that the following conditions
7# are met:
8# 1. Redistributions of source code must retain the above copyright
9#    notice, this list of conditions and the following disclaimer.
10# 2. Redistributions in binary form must reproduce the above copyright
11#    notice, this list of conditions and the following disclaimer in the
12#    documentation and/or other materials provided with the distribution.
13#
14# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
15# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
16# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
17# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
18# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
19# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
20# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
21# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
22# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
23# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
24# SUCH DAMAGE.
25#
26#
27
28# This is a wrapper script to run tools-nfs4.test on ZFS filesystem.
29#
30# WARNING: It uses hardcoded ZFS pool name "acltools"
31#
32# If any of the tests fails, here is how to debug it: go to
33# the directory with problematic filesystem mounted on it,
34# and do /path/to/test run /path/to/test tools-nfs4.test, e.g.
35#
36# /usr/src/tools/regression/acltools/run /usr/src/tools/regression/acltools/tools-nfs4.test
37#
38# Output should be obvious.
39
40if ! sysctl vfs.zfs.version.spa >/dev/null 2>&1; then
41	echo "1..0 # SKIP system doesn't have ZFS loaded"
42	exit 0
43fi
44if [ $(id -u) -ne 0 ]; then
45	echo "1..0 # SKIP you must be root"
46	exit 0
47fi
48
49echo "1..4"
50
51TESTDIR=$(dirname $(realpath $0))
52
53# Set up the test filesystem.
54MD=`mdconfig -at swap -s 64m`
55MNT=`mktemp -dt acltools`
56trap "cd /; zpool destroy -f acltools; rmdir $MNT; mdconfig -d -u $MD" EXIT
57zpool create -m $MNT acltools /dev/$MD
58if [ $? -ne 0 ]; then
59	echo "not ok 1 - 'zpool create' failed."
60	echo 'Bail out!'
61	exit 1
62fi
63
64echo "ok 1"
65
66cd $MNT
67
68# First, check whether we can crash the kernel by creating too many
69# entries.  For some reason this won't work in the test file.
70touch xxx
71setfacl -x2 xxx
72while :; do setfacl -a0 u:42:rwx:allow xxx 2> /dev/null; if [ $? -ne 0 ]; then break; fi; done
73chmod 600 xxx
74rm xxx
75echo "ok 2"
76
77perl $TESTDIR/run $TESTDIR/tools-nfs4-psarc.test >&2
78
79if [ $? -eq 0 ]; then
80	echo "ok 3"
81else
82	echo "not ok 3 # TODO: fails due to ACL changes in ZFS; bug 212323"
83fi
84
85echo "ok 4"
86